
float linearGenerator(float r) const {
    r = fabsf(r);
    if (r < 1.f) return 0.89538176f - 0.79076352f*r;
    else if (r==1.f) return 0.05230912f;
    else return 0.f;
}

float quadraticGenerator(float r) const {
    r = fabsf(r);
    if (r < 0.5f) return 0.66118661f - 0.75627421f*r*r;
    else if (r==0.5f) return 0.49205903f;
    else if (r < 1.5f) return 1.04366188f - 1.25239228f*r + 0.37813711f*r*r;
    else if (r==1.5f) return 0.00794097f;
    else return 0.f;
}

float cubicGenerator(float r) const {
    r = fabs(r);
    if (r==0.f) return 0.56259136f;
    else if (r < 1.f) return 0.56259136f + 0.04465421f*r - 0.70001154f*r*r + 0.30938685f*r*r*r;
    else if (r==1.f) return 0.21773426f;
    else if (r < 2.f) return 1.17739188f - 1.50921205f*r + 0.64059253f*r*r - 0.08992473f*r*r*r;
    else if (r==2.f) return 0.00097005f;
    else return 0.f;
}
